#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "shell.h"

char *ArchBaseGet(char *fullarch) {
  char *s,*ret = malloc(strlen(fullarch)+1);
  
  s = ret;
  if (*fullarch == '_') fullarch++;
  while (*fullarch && *fullarch != '_' && *fullarch != '-') {
    *(s++) = *(fullarch++);
  }
  *(s++) = 0;
  ret = realloc(ret,s-ret);
  return ret;
}

char *BuildInsert(char *filename,char *fullarch,char *build) {
  char **parts,*ret,*str = filename;
  int i,n;

  if (*fullarch == '_') fullarch++;
  ret = malloc(strlen(filename)+strlen(fullarch)+strlen(build)+8);
  parts = split(filename,'.');
  n = len(parts);
  strcpy(ret,parts[0]);
  strcat(ret,"-");
  strcat(ret,fullarch);
  strcat(ret,"-");
  strcat(ret,build);
  for (i=1;i<n;i++) {
    strcat(ret,".");
    strcat(ret,parts[i]);
  }
  /*
  return strf("%s.%s-%s",filename,fullarch,build);
  char *ret = malloc(strlen(filename)+strlen(build));
  strcpy(ret,filename);
  */
  return ret;
}

int main(int argc,char *argv[],char **env) {
  char **arches,**tops,*srcdir,*bindir,*project,*tarball,*arch,*dest,*dest0;
  char **products,*product,*srcfile,*destfile,*latest,*strip,*dest1;
  char *str,*build,*misc_files,*bin_dir;
  int islib,isdebug,tarfiles;
  int i,j,n,m;

  ShellDryRun = 1;
  for (i=0;env[i];i++) {
    sourceline(strappend("env.",env[i]));
  }
  source("BuildProcess.arch",0);
  source(varsubst("${env.PathToRoot}BuildProcess.user"),"make.");
  project=var("env.PROJECT");
  bin_dir = var("bin_dir");

  tarball=sort(ls("tarballs",varsubst("$env.PROJECT-(.*)\\.tar\\.gz")),0)[0];
  if (!tarball) {
    printf("Error: tarball for project %s not found!\n",project);
    return 1;
  }
  printf("TARBALL=%s\n",tarball);

  str = build = sort(map(ls(".","\\.build-"),cat1),0)[0];
  while (*str && *str != '-') str++;
  if (*str == '-') *str = 0;
  n = atoi(build);
  n--;
  build = strf("%d",n);
  printf("Build=%s\n",build);

  // BuildProcess.release
  // arches = all complete architectures we are compiling for
  // tops = all top-level architectures we are compiling for
  tops = uniq(map(arches=sort(grep(ls(".",0),"^_",1),1),ArchBaseGet));

  // copy source tarball to first location and symlink the rest
  n = len(tops);
  printf("Source tarball processing: %d arches\n",n);
  for (i=0;i<n;i++) {
    srcdir = var(strappend(tops[i],"_src"));
    if (srcdir[0]) {
      dest=strf("%s%s-src/%s-%s.tar.gz",srcdir,project,project,build);
      dest0=strf("%s-src/%s-%s.tar.gz",project,project,build);
      //printf("%s:%s\n",tops[i],dest);
      if (i == 0) {
	cp(dest,strappend("../",tarball));
	dest1 = dest; //strappend(strappend(project,"-src/"),tarball);
      } else {
	symlink1(dest,pathbetween(dest1,dest));
      }
      symlink1(strf("%s%s-src-LATEST.tar.gz",srcdir,project),dest0);
    }
  }

  n = len(arches);
  printf("Binaries processing: %d arches\n",n);
  for (i=0;i<n;i++) {
    assign("FULLARCH",&arches[i][1]);
    arch = ArchBaseGet(arches[i]);
    assign("ARCH",arch);
    bindir = var(strappend(arch,"_bin"));
    if (!bindir[0]) continue;

    isdebug=grep1(arches[i],"_debug");
    if (bin_dir[0]) {
      system1("mkdir tmp");
      tarfiles=0;
    }
    products = ls(".",strf("\\.build-(.*)-%s$",&arches[i][1]));
    m = len(products);
    for (j=0;j<m;j++) {
      product=strsub(products[j],7,strlen(products[j])-strlen(arches[i])-1);
      //str = build = cat(products[j])[0];
      //while (*str && *str != '-') str++;
      //if (*str == '-') *str = 0;
      srcfile=strf("product%s/%s",arches[i],product);
      islib=grep1(product,".*\\.a$");
      if (!bin_dir[0] || islib) {
	destfile=BuildInsert(product,arches[i],build);
	latest=BuildInsert(product,arches[i],"LATEST");
	cp(dest=strf("%s/%s/%s",bindir,project,destfile),srcfile);
	if (!islib && !isdebug) {
	  strip = strappend(var(strf("make.prefix_%s",arch)),"strip");
	  system1(strf("%s %s",strip,dest));
	}
	symlink1(strf("%s/%s",bindir,latest),strf("%s/%s",project,destfile));
      } else {
	cp(dest=strf("tmp%s/%s",bin_dir,product),srcfile);
	if (!islib && !isdebug) { 
	  strip = strappend(var(strf("make.prefix_%s",arch)),"strip");
	  system1(strf("%s %s",strip,dest));
	}
	tarfiles++;
      }
    }
    if (bin_dir[0]) {
      char **misc_files = split(var("misc_files"),' ');
      m = len(misc_files);
      for (j=0;j<m;j++) {
	char *in = varsubst(var(strappend(misc_files[j],"_in")));
	char *out = varsubst(var(strappend(misc_files[j],"_out")));
	if (!in[0] || !out[0]) continue;
	cp(strappend("tmp",out),in);
      }
    }
    if (bin_dir[0]) {
      if (tarfiles > 0) {
	tarczf("../tarball.tar.gz","tmp",".");
	destfile=BuildInsert(product,arches[i],build);
	latest=BuildInsert(product,arches[i],"LATEST");
	mv(dest=strf("%s/%s/%s.tar.gz",bindir,project,destfile),
	   "tarball.tar.gz");
	symlink1(strf("%s/%s.tar.gz",bindir,latest),dest);
      }
      system1("rm -fr tmp");
    }
  }
  return 0;
}

/*
Release process sources BuildProcess.arch in the project directory.
This can be a symlink to a common file for all projects using the same
release parameters.
Shell variables control how the project is released.

1. If bin_dir is not defined, then each binary is copied separately to
the release directory with its build number in the name, and a symlink
containing LATEST in the name is created in the parent directory.
   If bin_dir is defined, all executables in the project will be put
   in a tarball.  The bin_dir variable contains the path from the root
   to put the executables in.
   Next, if misc_files is defined, it contains a list of names.
   Each name refers to another file that is to be packaged into the
   tarball.   For each name, two variable names are constructed,
   one by appending _in to the name, and one by appending _out to the
   name.  The former contains the path to the file to copy, relative
   to the project directory.  The latter contains the path to copy
   to relative to the root of the tarball.  Both of these names will
   be subject to variable substitution, and the variables ARCH and
   FULLARCH will be defined according to the architecture currently
   being considered:
   ARCH being the name of the current base top-level architecture
   FULLARCH being the full name of the current architecture

2. Library files are always released as if bin_dir was not defined for them.

bin_dir=/bin
misc_files=config
config_out=/etc/dioctl.config
config_in='$ARCH.dioctl.config'

*/
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2012, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
