#include "Cavium2132DIORaw.h"
#define LOCK_NOW -1

#define I(x) ( Num<0 ? ~(x) : (x))

#define LOCK_TYPE_SHARED_DEFERRED
#define LOCK_CLASS Cavium2132DIORaw
#include "TSLock.h"

static DIORawAPI Cavium2132DIORawAPI = {
  .Init = (void *)Cavium2132DIORawInit,
  .Fini = (void *)Cavium2132DIORawFini,
  .Lock = (void *)Cavium2132DIORawLock,
  .Unlock = (void *)Cavium2132DIORawUnlock,
  .Preempt = (void *)Cavium2132DIORawPreempt,
  .DirSet = (void *)Cavium2132DIORawDirSet,
  .DataSet = (void *)Cavium2132DIORawDataSet,
  .DirGet = (void *)Cavium2132DIORawDirGet,
  .DataGet = (void *)Cavium2132DIORawDataGet,
  .Count = (void *)Cavium2132DIORawCount
};

void *Cavium2132DIORawInit(Cavium2132DIORaw *dio,void *bus1) {
  Bus *bus = bus1;

  if (dio->InitStatus > 0) return dio;
  dio->API = &Cavium2132DIORawAPI;
  Cavium2132DIORawLockInit(dio);
  dio->sub = bus;
  if (dio->sub->InitStatus <= 0) {
    dio->InitStatus = -1;
    return dio;
  }
  dio->InitStatus = 1;
  return dio;
}

void Cavium2132DIORawFini(Cavium2132DIORaw *dio) {
  dio->sub->API->Fini(dio->sub);
  if (dio->InitStatus > 0) dio->InitStatus = 0;
}

void Cavium2132DIORawDirSet(Cavium2132DIORaw *dio,int Num,int asOutput) {
  if (I(Num) > 31) return;
  Cavium2132DIORawLockReal(dio,0);
  dio->sub->API->BitAssign32(dio->sub,I(0x08),I(Num),asOutput);
}

void Cavium2132DIORawDataSet(Cavium2132DIORaw *dio,int Num,int asHigh) {
  if (I(Num) > 31) return;
  Cavium2132DIORawLockReal(dio,0);
  dio->sub->API->BitAssign32(dio->sub,I(0x00),I(Num),asHigh);
}

int Cavium2132DIORawDirGet(Cavium2132DIORaw *dio,int Num) {
  if (I(Num) > 31) return;
  Cavium2132DIORawLockReal(dio,SHARED);
  return dio->sub->API->BitGet32(dio->sub,I(0x08),I(Num));
}

int Cavium2132DIORawDataGet(Cavium2132DIORaw *dio,int Num) {
  if (I(Num) > 31) return;
  Cavium2132DIORawLockReal(dio,SHARED);
  return dio->sub->API->BitGet32(dio->sub,I(0x04),I(Num));
}

unsigned Cavium2132DIORawCount(Cavium2132DIORaw *dio) {
  return 32;
}

// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
