#include <stdlib.h>
#include "Cavium2132SBusWindowBus.h"
#include "Bit.h"

static BusAPI Cavium2132SBusWindowBusAPI = {
  .Init = (void *)Cavium2132SBusWindowBusInit,
  .Fini = (void *)Cavium2132SBusWindowBusFini,
  .Lock = (void *)Cavium2132SBusWindowBusLock,
  .Unlock = (void *)Cavium2132SBusWindowBusUnlock,
  .Preempt = (void *)Cavium2132SBusWindowBusPreempt,
  .Peek8 = (void *)Cavium2132SBusWindowBusPeek8,
  .Poke8 = (void *)Cavium2132SBusWindowBusPoke8,
  .Peek16 = (void *)Cavium2132SBusWindowBusPeek16,
  .Poke16 = (void *)Cavium2132SBusWindowBusPoke16,
  .Peek32 = (void *)Cavium2132SBusWindowBusPeek32,
  .Poke32 = (void *)Cavium2132SBusWindowBusPoke32,
  .BitGet8 = (void *)Cavium2132SBusWindowBusBitGet8,
  .BitAssign8 = (void *)Cavium2132SBusWindowBusBitAssign8,
  .BitSet8 = (void *)Cavium2132SBusWindowBusBitSet8,
  .BitClear8 = (void *)Cavium2132SBusWindowBusBitClear8,
  .BitGet16 = (void *)Cavium2132SBusWindowBusBitGet16,
  .BitAssign16 = (void *)Cavium2132SBusWindowBusBitAssign16,
  .BitSet16 = (void *)Cavium2132SBusWindowBusBitSet16,
  .BitClear16 = (void *)Cavium2132SBusWindowBusBitClear16,
  .BitGet32 = (void *)Cavium2132SBusWindowBusBitGet32,
  .BitAssign32 = (void *)Cavium2132SBusWindowBusBitAssign32,
  .BitSet32 = (void *)Cavium2132SBusWindowBusBitSet32,
  .BitClear32 = (void *)Cavium2132SBusWindowBusBitClear32,
  .PeekStream = (void *)Cavium2132SBusWindowBusPeekStream,
  .PokeStream = (void *)Cavium2132SBusWindowBusPokeStream,
  .Refresh = (void *)Cavium2132SBusWindowBusRefresh,
  .Commit = (void *)Cavium2132SBusWindowBusCommit,
  .BitToggle8 = (void *)Cavium2132SBusWindowBusBitToggle8,
  .BitToggle16 = (void *)Cavium2132SBusWindowBusBitToggle16,
  .BitToggle32 = (void *)Cavium2132SBusWindowBusBitToggle32,
  .Assign8X = (void *)Cavium2132SBusWindowBusAssign8X,
  .Assign16X = (void *)Cavium2132SBusWindowBusAssign16X,
  .Assign32X = (void *)Cavium2132SBusWindowBusAssign32X,
  .BitsGet8 = (void *)Cavium2132SBusWindowBusBitsGet8,
  .BitsGet16 = (void *)Cavium2132SBusWindowBusBitsGet16,
  .BitsGet32 = (void *)Cavium2132SBusWindowBusBitsGet32
};

void *Cavium2132SBusWindowBusInit(Cavium2132SBusWindowBus *bus,void *sbus0) {
  if (bus->InitStatus > 0) return bus;
  bus->sbus = sbus0;
  if (bus->sbus->InitStatus < 0) {
    bus->API->Fini(bus);
    bus->InitStatus = -1;
    return bus;
  }
  bus->API = &Cavium2132SBusWindowBusAPI;
  bus->AdrsLast = -1;
  bus->InitStatus = 1;
  return bus;
}

void Cavium2132SBusWindowBusFini(Cavium2132SBusWindowBus *bus) {
  bus->sbus->API->Fini(bus->sbus);
  if (bus->InitStatus > 0) bus->InitStatus = 0;
}

static unsigned char _Cavium2132SBusWindowBusPeek8(Cavium2132SBusWindowBus *bus,int adr){
  unsigned char ret;

  if (adr != bus->AdrsLast) {
    bus->sbus->API->Poke16(bus->sbus,bus->MemBase,adr);
  }
  bus->AdrsLast = adr + 1;
  ret = bus->sbus->API->Peek16(bus->sbus,bus->MemBase+2) & 0xFF;
  return ret;
}

int Cavium2132SBusWindowBusLock(Cavium2132SBusWindowBus *bus,
				unsigned num,int flags) {
  return bus->sbus->API->Lock(bus->sbus,num,flags);
}

int Cavium2132SBusWindowBusUnlock(Cavium2132SBusWindowBus *bus,
				unsigned num,int flags) {
  return bus->sbus->API->Unlock(bus->sbus,num,flags);
}

int Cavium2132SBusWindowBusPreempt(Cavium2132SBusWindowBus *bus) {
  return bus->sbus->API->Preempt(bus->sbus);
}

static void _Cavium2132SBusWindowBusPoke8(Cavium2132SBusWindowBus *bus,int adr, unsigned char dat){
  dat &= 0xFF;
  bus->sbus->API->Poke16(bus->sbus,bus->MemBase+6,adr<<8 | dat);
  bus->AdrsLast = adr + 1;
}

static unsigned short _Cavium2132SBusWindowBusPeek16(Cavium2132SBusWindowBus *bus,int adr){
  return 0; // unsupported
}

static void _Cavium2132SBusWindowBusPoke16(Cavium2132SBusWindowBus *bus,int adr, unsigned short dat){
  // unsupported
}

static unsigned _Cavium2132SBusWindowBusPeek32(Cavium2132SBusWindowBus *bus,int adr){
  // unsupported
}

static void _Cavium2132SBusWindowBusPoke32(Cavium2132SBusWindowBus *bus,int adr, unsigned dat){
  // unsupported
}

void Cavium2132SBusWindowBusPeekStream(Cavium2132SBusWindowBus *bus,int adr,int dir,char *buf,int len){
  if (len <= 0) return;
  if (adr != bus->AdrsLast) {
    bus->sbus->API->Poke16(bus->sbus,bus->MemBase,adr);
  }
  bus->AdrsLast = adr + len;
  while (len >= 2) {
    unsigned int s = bus->sbus->API->Peek16(bus->sbus,bus->MemBase+4);
    *buf++ = s & 0xff;
    *buf++ = s >> 8;
    len -= 2;
  }
  if (len) *buf = bus->sbus->API->Peek16(bus->sbus,bus->MemBase+2) & 0xFF;
}

void Cavium2132SBusWindowBusPokeStream(Cavium2132SBusWindowBus *bus,int adr,int dir,char *buf,int len){
  int na = adr + len + 1;
  if (len <= 0) return;

  if (adr != bus->AdrsLast) {
    // The next two lines of code are equivalent to:
    //     bus->Poke8(bus->sbus,adr, *buf++);
    // except that we don't try to lock the SBus, because we already
    // have the lock!
    bus->sbus->API->Poke16(bus->sbus,bus->MemBase+6,adr<<8 | *buf++);
    bus->AdrsLast = adr + 1;
    len--;
  } 
	
  bus->AdrsLast = na;

  while (len >= 2) {
    unsigned int s;
    s = *buf++;
    s |= *buf++ << 8;
    bus->sbus->API->Poke16(bus->sbus,bus->MemBase+4, s);
    len -= 2;
  }

  if (len) bus->sbus->API->Poke16(bus->sbus,bus->MemBase+2, *buf);
}

DefinitionFunctionsBit(Cavium2132SBusWindowBus,unsigned char,8)
DefinitionFunctionsBit(Cavium2132SBusWindowBus,unsigned short,16)
DefinitionFunctionsBit(Cavium2132SBusWindowBus,unsigned,32)

void Cavium2132SBusWindowBusRefresh(Cavium2132SBusWindowBus *bus) {
  bus->sbus->API->Refresh(bus->sbus->API);
}

void Cavium2132SBusWindowBusCommit(Cavium2132SBusWindowBus *bus,int forceall) {
  bus->sbus->API->Commit(bus->sbus,forceall);
}
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
