#ifndef __QueueBytes_h
#define __QueueBytes_h

typedef struct QueueBytes QueueBytes;

// nomenclature:
// we treat our queue like a line
// you enter the line at the end (tail) and come out at the front (head)
// tail points to the next location to put a byte
// head points to the next location to get a byte
// head == tail means empty, so we waste 1 byte on full
struct QueueBytes {
  char *buffer;
  int tail,head;
  int len;
};

QueueBytes *QueueBytesInit(QueueBytes *,int length);
void QueueBytesFini(QueueBytes *);
int QueueBytesSize(QueueBytes *q);
int QueueBytesResize(QueueBytes *q,int length);
int QueueBytesReady(QueueBytes *q);
int QueueBytesFree(QueueBytes *q);
int QueueBytesEnqueue(QueueBytes *q,char *bytes,int length);
int QueueBytesDequeue(QueueBytes *q,char *bytes,int length);
char *QueueBytesEnqueuePrep(QueueBytes *q,int length,int *actualLength);
char *QueueBytesDequeuePrep(QueueBytes *q,int length,int *actualLength);
int QueueBytesUnEnqueue(QueueBytes *q,int length);
int QueueBytesUnDequeue(QueueBytes *q,int length);

#endif
