#ifndef __libtsctlclient_h
#define __libtsctlclient_h
#include "Bus.h"
#include "CAN.h"
#include "DIORaw.h"
#include "DIO.h"
#include "Pin.h"
#include "Time.h"
#include "TWI.h"
#include "SPI.h"
#include "AIO.h"

Time *Net_TimeInit(int inst,char *host,int mode);
Bus *Net_BusInit(int inst,char *host,int mode);
Pin *Net_PinInit(int inst,char *host,int mode);
CAN *Net_CANInit(int inst,char *host,int mode);
DIORaw *Net_DIORawInit(int inst,char *host,int mode);
DIO *Net_DIOInit(int inst,char *host,int mode);
TWI *Net_TWIInit(int inst,char *host,int mode);
SPI *Net_SPIInit(int inst,char *host,int mode);
AIO *Net_AIOInit(int inst,char *host,int mode);

void Net_TimeFini(void *);
void Net_BusFini(void *);
void Net_PinFini(void *);
void Net_CANFini(void *);
void Net_DIORawFini(void *);
void Net_DIOFini(void *);
void Net_TWIFini(void *);
void Net_SPIFini(void *);
void Net_AIOFini(void *);

enum {
  NetModeBlocking=0, // all calls block until server returns completion
  NetModeNonBlocking=1, // calls to functions return void return immediately
  NetModeQueued=2 // we don't send commands to server until 
  // function returning non-void is called.
  // caller is responsible for making sure it doesn't queue too many
  // commands (and run out of transmit buffer space)
};

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
