#include <stdarg.h>
#include <sys/time.h>
#include <string.h>
#include <pthread.h>
#include <stdio.h>
#include "logf.h"

/*
    for (i=0;i<logconns;i++) {
      if (flags & LC[i].flags) {
	if (LC[i].flags & LOG_TIME) {
	}
	if (write(LC[i].socket,str,len) <= 0) {
	  close(LC[i].socket);
	  for (j=i;j<logconns-1;j++) {
	    LC[j] = LC[j+1];
	  }
	  logconns--;
	  logflags = 0;
	  for (j=0;j<logconns;j++) {
	    logflags |= LC[j].flags;
	  }
	  i--; // so i++ won't skip next element
	}
      }
    }

 */
pthread_mutex_t loglock = PTHREAD_MUTEX_INITIALIZER;

void _log9(int flags,char *buffer,int len) {
  write(2,buffer,len);
}
int Log9Flags=-1;

void log9(int flags,char *file, int line, const char *func, char *format,...) {
  if ((Log9Flags & flags) == 0) return;

  int i,j,len,len2,len3;
  va_list ap;
  char dummy[1];

  va_start(ap, format);
  len = vsnprintf(dummy,0,format,ap);
  if (flags & LOG_FILELINE) {
    len2 = snprintf(dummy,0,"%s:%d:",file,line);
    len += len2;
  }
  if (flags & LOG_FUNCTION) {
    len3 = 1+strlen(func);
    len += len3;
  }
  if (flags & LOG_TIMESTAMP) len += 18;
  {
    char str[len],*s=str;
    if (flags & LOG_TIMESTAMP) {
      struct timeval t;
      gettimeofday(&t,0);
      sprintf(s,"%10d.%06d:",t.tv_sec,t.tv_usec);
      s += 18;
    }
    if (flags & LOG_FILELINE) {
      sprintf(s,"%s:%d:",file,line);
      s += len2;
    }
    if (flags & LOG_FUNCTION) {
      sprintf(s,"%s:",func);
      s += len3;
    }
    vsprintf(s,format,ap);

    pthread_mutex_lock(&loglock);
    _log9(flags,str,len);
    pthread_mutex_unlock(&loglock);
  }
  va_end(ap);
}
