#ifndef __logf_h
#define __logf_h
#include <assert.h>

#define assertf(expr,fmt,...) if (!(expr)) { fprintf(stderr,"%s:%d:%s:" fmt "\n",__FILE__,__LINE__,__PRETTY_FUNCTION__,##__VA_ARGS__); exit(3); }
#define Log9(flags,format,...) log9(flags,__FILE__,__LINE__,__PRETTY_FUNCTION__,format,##__VA_ARGS__)

enum {
  LOG_SYSTEM=0x01,
  LOG_BUS=0x02,
  LOG_TIME=0x04,
  LOG_PIN=0x08,
  LOG_DIORAW=0x10,
  LOG_DIO=0x20,
  LOG_TWI=0x40,
  LOG_CAN=0x80,
  LOG_SPI=0x100,
  LOG_ASSERT=0x100000,
  LOG_THREAD=0x200000,
  LOG_DIOCTL=0x400000,
  LOG_TIMESTAMP=0x800000,
  LOG_ENTER=0x10000000, LOG_RETURN=0x08000000,
  LOG_FILELINE=0x80000000, LOG_FUNCTION=0x40000000, LOG_THREADID=0x20000000,
  LOG_INFO=0xD0000000
};

extern int Log9Flags;
void _log9(int flags,char *buffer,int len) __attribute__ ((weak));
void log9(int flags,char *file, int line, const char *func, char *format,...);
#endif
