#!/usr/bin/python

# usage:
# TestPin.py <host>

# This regression test verifies that our Pin object mechanism is
# working correctly on a TS-4500.


from Pin import *

pin = Pin(tsctl(sys.argv[1]))
#pin.tsctl.s.settimeout(1)

pin.Lock(WaitLock)
mode15 = pin.ModeGet(15)
if (mode15 != MODE_CAN and mode15 != MODE_DIO):
    print "Error: Pin 15 mode = "+str(mode15)
    exit(1)
if (mode15 == MODE_CAN):
    pin.ModeSet(15,MODE_DIO)
    if pin.ModeGet(15) != MODE_DIO:
        print "Failed to set Pin 15 to DIO"
        exit(1)
    pin.ModeSet(15,MODE_CAN)
    if pin.ModeGet(15) != MODE_CAN:
        print "Failed to set Pin 15 back to CAN"
        exit(1)
else:
    pin.ModeSet(15,MODE_CAN)
    if pin.ModeGet(15) != MODE_CAN:
        print "Failed to set Pin 15 to CAN"
        exit(1)
    pin.ModeSet(15,MODE_DIO)
    if pin.ModeGet(15) != MODE_DIO:
        print "Failed to set Pin 15 back to DIO"
        exit(1)

pin.Lock(DoRelease)


# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2011, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
