#!/usr/bin/python

# usage:
# TestSystem.py <host> <show>

# This code reads the system information from the server
# if the <show> parameter is present, it displays this info,
# otherwise it just sanity checks it

from System import *
import sys
import random

system = System(tsctl(sys.argv[1]))
system.tsctl.s.settimeout(1)

# number of released classes
ccmin=9 
# minimum number of instances on any released board per class
# this may change as more boards are supported by tsctl
icmin=[1,7,1,1,2,3,0,0,0]
# minimum number of released API functions per class
acmin=[3,26,7,3,5,7,3,4,0]

cc=system.ClassCount()
if len(sys.argv) > 2:
    print str(cc)+" classes"
if cc < ccmin:
    print "Expect at least "+str(ccmin)+" classes, got "+str(cc)
    exit(1)

for i in xrange(cc):
    ic=system.InstanceCount(i)
    ac=system.APICount(i)
    if len(sys.argv) > 2:
        print("class "+str(i)+" has "+str(ic)+" instances and "+
              str(ac)+" functions")
    if ic < icmin[i]:
        print("class "+str(i)+":expect at least "+str(icmin[i])+
              " instances, got "+str(ic))
        exit(1)
    if ac < acmin[i]:
        print("class "+str(i)+":expect at least "+str(acmin[i])+
              " API functions, got "+str(ac))
        exit(1)

if len(sys.argv) > 2:
    count = system.LockCount()
    print str(count)+" locks"
    
    lh = system.LockHolderInfo()
    #items = list(lh)
    #print [items[i::2] for i in range(2)]

    print str(lh)

# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2011, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
