#!/usr/bin/python

# usage:
# TestTWI3.py <host> <show>

# This program requires tsctl server to be running on a host
# which has a TMP124 temp sensor connected to the default
# TWI lines for the board.

from TWI import *

# behavior 2: test reading the temp sensor (this tests Write)
twi2 = TWI(tsctl(sys.argv[1]),0)
twi2.tsctl.s.settimeout(1)
twi2.Lock(WaitLock)

try:
    data = twi2.Read(0x49,1,0x07,2)
except socket.timeout:
    print "Error: Read timeout"
    exit(1)

if data != "\x01\x90":
    print "Error detecting temp sensor (Got "+repr(data)+")"
    exit(1)

try:
    if twi2.Write(0x49,1,0x01,"\xC0\x01") < 0:
        print "Error writing first register"
        exit(1)

    if twi2.Write(0x49,0,0x00,"\x40\x01") < 0:
        print "Error writing second register"
        exit(1)
except socket.timeout:
    print "Error: Write timeout"
    exit(1)

try:
    data = twi2.Read(0x49,1,0x00,2)
except socket.timeout:
    print "Error: Read timeout"
    exit(1)
C=(ord(data[0])*256+ord(data[1])) / 128.0
F=C * 9 / 5 + 32
if (F > 130):
    print "Too hot! "+str(F)+"F"
    exit(1)
if (F < 60):
    print "Too cold! "+str(F)+"F"
    exit(1)
if len(sys.argv) > 2:
    print str(F)+"F"
    print str(C)+"C"

# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2011, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
