#!/usr/bin/python

# usage:
# TestTime2.py <host>

# test non-blocking mode

from Time import *
from Bus import *
import sys
import random
import time

tsctl=tsctl(sys.argv[1],NetModeNonBlocking)
#tsctl.s.settimeout(1)
time0 = Time(tsctl,0)
bus = Bus(tsctl,1)

bus.Poke8(0,0)
n=bus.Peek8(0)
if n != 0:
    print "Failed to Poke8 (1)"
    exit(1)

t1=time.time()
time0.Delay(250000)
bus.Poke8(0,0x55)
t2=time.time()
tnet1=t2-t1
if tnet1 > 0.001:
    print "Waited too long for Poke8 (2): "+str(tnet1)+" > 1ms"
    exit(1)
#tsctl.s.settimeout(1)
n=bus.Peek8(0)
t3=time.time()
tnet2=t3-t2
if n != 0x55:
    print "Failed to Poke8 (2) "+str(n)
    exit(1)
if tnet2 < 0.248: # was 0.25, but that caused failures when running in a VM
    print "Waited too short for Peek8: "+str(tnet2)+" < 250ms"
    exit(1)



# to do: read back before delay on another connection
# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2011, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
