#!/usr/bin/python

from dioctl import *
from DIO import *
import sys
import time

dioctl1 = dioctl(sys.argv[1])
dio1 = DIO(tsctl(sys.argv[1]),0)

model = dioctl1.ModelId();
if ((model & 61440) == 16384):
    sys.stderr.write("detecting baseboard\r")
    adrs0 = dioctl1.Lookup("CN2_6")
    if adrs0 == -1:
        print "Can't find CN2_6"
        exit(1)
    adrs1 = dioctl1.Lookup("CN2_8")
    if adrs1 == -1:
        print "Can't find CN2_8"
        exit(1)
    adrs2 = dioctl1.Lookup("CN1_98")
    if adrs2 == -1:
        print "Can't find CN1_98"
        exit(1)
    inbit = dioctl1.Lookup("CN1_83")
    if inbit == -1:
        print "Can't find CN1_83"
        exit(1)
    extrabit = dioctl1.Lookup("CN1_85")
    if extrabit == -1:
        print "Can't find CN1_85"
        exit(1)

    saveCN2_6 = dioctl1.GetAsync(adrs0)
    saveCN2_8 = dioctl1.GetAsync(adrs1)
    saveCN1_98 = dioctl1.GetAsync(adrs2)
    saveCN1_83 = dioctl1.GetAsync(inbit)
    saveCN1_85 = dioctl1.GetAsync(extrabit)

    dioctl1.SetAsync(inbit,INPUT)
    value=0
    dioctl1.SetAsync(extrabit,INPUT)
    for i in range(7,-1,-1):
        dioctl1.SetAsync(adrs0,LOW if i&1 else HIGH)
        dioctl1.SetAsync(adrs1,LOW if i&2 else HIGH)
        dioctl1.SetAsync(adrs2,HIGH if i&4 else LOW)
        value <<= 1
        tmp = dioctl1.GetAsync(inbit)
        value |= (3+dioctl1.GetAsync(inbit))

    if saveCN2_6 < 0: saveCN2_6 = -1
    if saveCN2_8 < 0: saveCN2_8 = -1
    if saveCN1_98 < 0: saveCN1_98 = -1
    if saveCN1_83 < 0: saveCN1_83 = -1
    if saveCN1_85 < 0: saveCN1_85 = -1
    dioctl1.SetAsync(adrs0,saveCN2_6)
    dioctl1.SetAsync(adrs1,saveCN2_8)
    dioctl1.SetAsync(adrs2,saveCN1_98)
    saveCN1_98 = dioctl1.GetAsync(adrs2)

    dioctl1.SetAsync(inbit,saveCN1_83)
    dioctl1.SetAsync(extrabit,saveCN1_85)

    value = value & 0x3F
    rev = value >> 6

    if value == 0x30:
        id=0x9490
    elif value == 1:
        id=0x8395
    elif value == 2:
        id=0x8390
    elif value == 3:
        id=0x8510
    elif value == 4:
        id=0x8500
    elif value == 6:
        id=0x8160
    elif value == 7:
        id=0x8100
    elif value == 10:
        id=0x8900
    elif value == 0:
        id=0x8200
    elif value == 0x3F:
        id=0x8200
    else:
        id=0

    sys.stderr.write("                   \r")
    if id == 0:
        print "unknown base board id "+hex(value)
        if len(sys.argv) < 4:
            exit(1)
#       else:
#           print hex(id)

# read the config file for the base board in use
# create a nested list structure as follows:
# each element in the top-level of the list describes a wire
# each wire has an element for each connection to the wire
# each connector is described as connector number and pin number
# note: all connector numbers start at 1

    model=hex(id)[2:6]
    if len(sys.argv) > 2:
        file = sys.argv[2]
        #print "using "+file
    else:
        file="ts"+model+".dioctl.config"
    if len(sys.argv) > 3:
        model = sys.argv[3]
else:
    model=sys.argv[2]
    file="ts"+model+".dioctl.config"

rex0=r"attrib."+model+".Wire.MaxConnections=([0-9]*)"
rex1=r"attrib."+model+".Wire.Count=([0-9]*)"
rex2=r"attrib."+model+".Wire.Connector.([0-9]*).([0-9]*)=([0-9]*)"
rex3=r"attrib."+model+".Wire.Pin.([0-9]*).([0-9]*)=([0-9]*)"
maxc=0
count=0

f=open(file,'r')
while True:
    str1=f.readline()
    if not str1:
        break
    m=re.match(rex2,str1)
    if m:
        x=int(m.group(1))
        y=int(m.group(2))
        z=int(m.group(3))
        wires[x][y][0]=z
    else:
        m=re.match(rex3,str1)
        if m:
            x=int(m.group(1))
            y=int(m.group(2))
            z=int(m.group(3))
            wires[x][y][1]=z
        else:
            m=re.match(rex0,str1)
            if m:
                maxc=int(m.group(1))
                if count > 0:
                    wires=[[[0 for i in range(2)] for i in range(maxc)] for i in range(count)]
            else:
                m=re.match(rex1,str1)
                if m:
                    count=int(m.group(1))
                    if maxc > 0:
                        wires=[[[0 for i in range(2)] for i in range(maxc)] for i in range(count)]

# loop up connector names
ccount=1+int(dioctl1.Lookup("attrib.Connector.Count"))
cns=["NULL" for i in range(ccount)]

for i in range(ccount):
    cns[i]=dioctl1.LookupPartial("attrib.Connector.Name.",i)
    cns[i]=cns[i][22:]
    #print "connector["+str(i)+"]="+cns[i]

# now convert the bottom level [connector#, pin number] to DIO numbers

for i in range(len(wires)):
    for j in range(len(wires[i])):
        if wires[i][j][0] == 0:
            wires[i][j]=-1
        else:
            name=cns[wires[i][j][0]]+str(wires[i][j][1])
#            print "name="+name
#            name="CN"+str(wires[i][j][0])+"_"+str(wires[i][j][1])
            num=dioctl1.Lookup(name)
            wires[i][j]=num

# remove all elements that do not contain valid DIO numbers
wires2 = [[x for x in w if x!=-1] for w in wires]
# remove empty tests
wires3 = [x for x in wires2 if x!=[]]

sys.stderr.write("                   \r")
#print str(len(wires3))+" tests"
#print repr(wires3)
# Now run the tests...

tst=0
x=0
for dio in [ dioctl1 ]:
#for dio in [ dioctl1, dio1 ]:
    errors=0
    y = len(wires3)
    x += 1
    #input("Press enter to run Test "+str(tst))
    tst += 1
    for pins in wires3:
        sys.stderr.write(str(x)+"-"+str(y)+"  \r")
        y -= 1
        #print "test:"+repr(pins)
        for j in pins:
            dio.Lock(WaitLock,j)
        # for each pin, set it high or low and all other pins as input 
        # then verify that all other pins read input high or low

        # LOW test
        for i in range(len(pins)):
            for j in pins:
                dio.SetAsync(j,INPUT)
            dio.SetAsync(pins[i],LOW)
            time.sleep(0.05)
            for i2 in range(len(pins)):
                got=dio.GetAsync(pins[i2])
                if i == i2 and got!=LOW:
                    print "Failed to drive "+str(pins[i])+" Low (got "+DIOState(got)+")"
                    errors+=1
                elif i != i2 and got!=INPUT_LOW:
                    print str(pins[i])+" Low failed to pull "+str(pins[i2])+" (got "+DIOState(got)+")"
                    errors+=1

        # HIGH test
        for i in range(len(pins)):
            for j in pins:
                dio.SetAsync(j,INPUT)
            dio.SetAsync(pins[i],HIGH)
            time.sleep(0.05)
            for i2 in range(len(pins)):
                got=dio.GetAsync(pins[i2])
                if i == i2 and got!=HIGH:
                    print "Failed to drive "+str(pins[i])+" High (got "+DIOState(got)+")"
                    errors+=1
                elif i != i2 and got!=INPUT_HIGH:
                    print str(pins[i])+" High failed to pull "+str(pins[i2])+" (got "+DIOState(got)+")"
                    errors+=1

        for j in pins:
            dio.Lock(DoRelease,j)
    if errors > 0:
        print str(errors)+"/"+str(8*len(wires3))+" FAILED---------"
# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2011, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
