#include <string.h>
#include "MMapBus.c"
#include "TSMuxBus.c"
#include "CacheBus.c"
#include "ts4200Pin.c"
#include "AtmelAT91DIORaw.c"
#include "ts4200DIORaw.c"
#include "SystemTime.c"
#include "PhysicalDIO.c"
#include "AggregateDIO.c"
#include "DIOTWI.c"
#include "AtmelAT91SPI.c"
#include "LocalSystem.c"
/*
#include "SJA1000CAN.c"
*/
#include "ts4200.h"
#include "arch.h"

Time *TimeInit(int inst);
Bus *BusInit(int inst);
Pin *PinInit(int inst);
CAN *CANInit(int inst);
DIORaw *DIORawInit(int inst);
DIO *DIOInit(int inst);
TWI *TWIInit(int inst);
SPI *SPIInit(int inst);
AIO *AIOInit(int inst);

int ModelId=0x4200;

MMapBus AtmelAT91DIOBus1,
  AtmelAT91DIOBus2,
  AtmelAT91DIOBus3,
  ts4200SysConBus, testbus, muxbusreg8, muxbusreg16,pmcreg,spibus1;
TSMuxBus muxbus;
CacheBus AtmelAT91DIOCacheBus1,
  AtmelAT91DIOCacheBus2,
  AtmelAT91DIOCacheBus3,
  ts4200DIOCacheBus;
ts4200Pin ts4200Pin0;
AtmelAT91DIORaw AtmelAT91DIORaw1,
  AtmelAT91DIORaw2,
  AtmelAT91DIORaw3;
ts4200DIORaw ts4200DIORaw0;
PhysicalDIO AtmelAT91DIO1,
  AtmelAT91DIO2,
  AtmelAT91DIO3,
  ts4200DIO;
unsigned char AtmelAT91DIO1Capabilities[32];
unsigned char AtmelAT91DIO2Capabilities[32];
unsigned char AtmelAT91DIO3Capabilities[32];
unsigned char ts4200DIOCapabilities[34];
AggregateDIO DIO0;
DIOTWI TWI0;
AtmelAT91SPI SPI0;
SystemTime Time0;
System sys;

unsigned AtmelAT91DIOCacheBus_WO[16];
unsigned AtmelAT91DIOCacheBus_IBit[16];
unsigned AtmelAT91DIOCacheBus_OBit[16];
unsigned AtmelAT91DIOCacheBus1_icache[16];
unsigned AtmelAT91DIOCacheBus1_ocache[16];
unsigned AtmelAT91DIOCacheBus1_ocache0[16];
unsigned AtmelAT91DIOCacheBus2_icache[16];
unsigned AtmelAT91DIOCacheBus2_ocache[16];
unsigned AtmelAT91DIOCacheBus2_ocache0[16];
unsigned AtmelAT91DIOCacheBus3_icache[16];
unsigned AtmelAT91DIOCacheBus3_ocache[16];
unsigned AtmelAT91DIOCacheBus3_ocache0[16];  
unsigned ts4200DIOCacheBus_WO[11];
unsigned ts4200DIOCacheBus_IBit[11];
unsigned ts4200DIOCacheBus_OBit[11];
unsigned ts4200DIOCacheBus_icache[11];
unsigned ts4200DIOCacheBus_ocache[11];
unsigned ts4200DIOCacheBus_ocache0[11];

char testbusdata[4096];
TWI *TWIGet(int instance) {
  if (instance == 0) {
    //return (TWI *)&TWI0;
  }
  return 0;
}

void ts4200_ArchInit() {
  ThreadInit();
}

System *ts4200_SystemInit(System *s,int inst) {
  if (inst == 0) {
    return LocalSystemInit(&sys);
  }
  return s;
}

Time *ts4200_TimeInit(Time *t,int inst) {
  if (inst == 0) {
    return SystemTimeInit(&Time0);
  }
  return t;
}

static void CacheBusCommonInit() {
  AtmelAT91DIOCacheBus_IBit[6]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_IBit[15]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_OBit[0]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_OBit[4]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_OBit[5]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_OBit[12]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_OBit[13]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_WO[0]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_WO[1]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_WO[4]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_WO[5]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_WO[8]=0xFFFFFFFF;
  AtmelAT91DIOCacheBus_WO[9]=0xFFFFFFFF;
}

Bus *ts4200_BusInit(Bus *bus,int inst) {
  if (inst == 0) {  // ts4200SysConBus
    return MMapBusInit(&ts4200SysConBus,0x30000000,1);
  }
  if (inst == 1) { // for testing
    return MMapBusInit2(&testbus,testbusdata,1);
  }
  if (inst == 2) { // MUXBus
    return TSMuxBusInit(&muxbus,BusInit(0),0x20,BusInit(10),0,BusInit(11),0);
  }
  if (inst == 3) {  // ts4200DIOCacheBus (caches ts4200SysConBus for DIO)
    ts4200DIOCacheBus_IBit[3]=0xFFFF;
    ts4200DIOCacheBus_IBit[10]=0xFFFF;
    ts4200DIOCacheBus_OBit[0]=0xC000;
    ts4200DIOCacheBus_OBit[1]=0xFFFF;
    ts4200DIOCacheBus_OBit[2]=0xFFFF;
    ts4200DIOCacheBus_OBit[8]=0xFFFF;
    ts4200DIOCacheBus_OBit[9]=0xFFFF;
    
    ts4200DIOCacheBus.Length=11;
    ts4200DIOCacheBus.Width=16;
    ts4200DIOCacheBus.Offset=2;
    ts4200DIOCacheBus.WO = ts4200DIOCacheBus_WO;
    ts4200DIOCacheBus.IBit = ts4200DIOCacheBus_IBit;
    ts4200DIOCacheBus.OBit = ts4200DIOCacheBus_OBit;
    ts4200DIOCacheBus.icache=ts4200DIOCacheBus_icache;
    ts4200DIOCacheBus.ocache=ts4200DIOCacheBus_ocache;
    ts4200DIOCacheBus.ocache0=ts4200DIOCacheBus_ocache0;
    return CacheBusInit(&ts4200DIOCacheBus,BusInit(0));
  }
  if (inst == 4) {  // AtmelAT91DIOBus1
    return MMapBusInit(&AtmelAT91DIOBus1,0xFFFFF400,1);
  }
  if (inst == 5) {  // AtmelAT91DIOCacheBus1
    CacheBusCommonInit();
    AtmelAT91DIOCacheBus1.Length=16;
    AtmelAT91DIOCacheBus1.Width=32;
    AtmelAT91DIOCacheBus1.Offset=0;
    AtmelAT91DIOCacheBus1.WO = AtmelAT91DIOCacheBus_WO;
    AtmelAT91DIOCacheBus1.IBit = AtmelAT91DIOCacheBus_IBit;
    AtmelAT91DIOCacheBus1.OBit = AtmelAT91DIOCacheBus_OBit;
    AtmelAT91DIOCacheBus1.icache = AtmelAT91DIOCacheBus1_icache;
    AtmelAT91DIOCacheBus1.ocache = AtmelAT91DIOCacheBus1_ocache;
    AtmelAT91DIOCacheBus1.ocache0 = AtmelAT91DIOCacheBus1_ocache0;
    return CacheBusInit(&AtmelAT91DIOCacheBus1,BusInit(4));
  }
  if (inst == 6) {  // AtmelAT91DIOBus2
    return MMapBusInit(&AtmelAT91DIOBus2,0xFFFFF600,1);
  }
  if (inst == 7) {  // AtmelAT91DIOCacheBus2
    CacheBusCommonInit();
    AtmelAT91DIOCacheBus2.Length=16;
    AtmelAT91DIOCacheBus2.Width=32;
    AtmelAT91DIOCacheBus2.Offset=0;
    AtmelAT91DIOCacheBus2.WO = AtmelAT91DIOCacheBus_WO;
    AtmelAT91DIOCacheBus2.IBit = AtmelAT91DIOCacheBus_IBit;
    AtmelAT91DIOCacheBus2.OBit = AtmelAT91DIOCacheBus_OBit;
    AtmelAT91DIOCacheBus2.icache = AtmelAT91DIOCacheBus2_icache;
    AtmelAT91DIOCacheBus2.ocache = AtmelAT91DIOCacheBus2_ocache;
    AtmelAT91DIOCacheBus2.ocache0 = AtmelAT91DIOCacheBus2_ocache0;
    return CacheBusInit(&AtmelAT91DIOCacheBus2,BusInit(6));
  }
  if (inst == 8) {  // AtmelAT91DIOBus3
    return MMapBusInit(&AtmelAT91DIOBus3,0xFFFFF800,1);
  }
  if (inst == 9) {  // AtmelAT91DIOCacheBus3
    CacheBusCommonInit();
    AtmelAT91DIOCacheBus3.Length=16;
    AtmelAT91DIOCacheBus3.Width=32;
    AtmelAT91DIOCacheBus3.Offset=0;
    AtmelAT91DIOCacheBus3.WO = AtmelAT91DIOCacheBus_WO;
    AtmelAT91DIOCacheBus3.IBit = AtmelAT91DIOCacheBus_IBit;
    AtmelAT91DIOCacheBus3.OBit = AtmelAT91DIOCacheBus_OBit;
    AtmelAT91DIOCacheBus3.icache = AtmelAT91DIOCacheBus3_icache;
    AtmelAT91DIOCacheBus3.ocache = AtmelAT91DIOCacheBus3_ocache;
    AtmelAT91DIOCacheBus3.ocache0 = AtmelAT91DIOCacheBus3_ocache0;
    return CacheBusInit(&AtmelAT91DIOCacheBus3,BusInit(8));
  }
  if (inst == 10) {  // MuxBus regbus8
    return MMapBusInit(&muxbusreg8,0x10000400,1);
  }
  if (inst == 11) {  // MuxBus regbus16
    return MMapBusInit(&muxbusreg16,0x30000400,1);
  }
  if (inst == 12) { // PMC
    return MMapBusInit(&pmcreg,0xFFFFFC00,1);
  }
  if (inst == 13) { // SPI1
    return MMapBusInit(&spibus1,0xFFFCC000,1);
  }
  return bus;
}

Pin *ts4200_PinInit(Pin *pin,int inst) {
  if (inst == 0) {
    return ts4200PinInit(&ts4200Pin0,BusInit(0),BusInit(6),BusInit(12),
			 BusInit(8));
  }
  return pin;
}

CAN *ts4200_CANInit(CAN *can,int inst) {
  return can;
}

DIORaw *ts4200_DIORawInit(DIORaw *dioraw,int inst) {
  if (inst == 0) {
    return AtmelAT91DIORawInit(&AtmelAT91DIORaw1,BusInit(5));
  }
  if (inst == 1) {
    return AtmelAT91DIORawInit(&AtmelAT91DIORaw2,BusInit(7));
  }
  if (inst == 2) {
    return AtmelAT91DIORawInit(&AtmelAT91DIORaw3,BusInit(9));
  }
  if (inst == 3) {
    return ts4200DIORawInit(&ts4200DIORaw0,BusInit(3));
  }
  return dioraw;
}

DIO *ts4200_DIOInit(DIO *dio,int inst) {
  int i,j;
  if (inst == 1) {
    AtmelAT91DIO1Capabilities[6] = DIO_NORMAL;
    AtmelAT91DIO1Capabilities[9] = DIO_NORMAL;
    AtmelAT91DIO1Capabilities[22] = DIO_NORMAL;
    AtmelAT91DIO1Capabilities[23] = DIO_NORMAL;
    AtmelAT91DIO1Capabilities[24] = DIO_NORMAL;
    AtmelAT91DIO1Capabilities[30] = DIO_NORMAL;
    AtmelAT91DIO1Capabilities[31] = DIO_NORMAL;
    AtmelAT91DIO1.Capabilities = AtmelAT91DIO1Capabilities;
    return PhysicalDIOInit(&AtmelAT91DIO1,BusInit(5),DIORawInit(0));
  }
  if (inst == 2) {
    for (i=0;i<=13;i++) {
      AtmelAT91DIO2Capabilities[i] = DIO_NORMAL;
    }
    AtmelAT91DIO2Capabilities[16] = DIO_NORMAL;
    AtmelAT91DIO2Capabilities[17] = DIO_NORMAL;
    AtmelAT91DIO2Capabilities[18] = DIO_NORMAL;
    for (i=20;i<=30;i++) {
      AtmelAT91DIO2Capabilities[i] = DIO_NORMAL;
    }
    AtmelAT91DIO2.Capabilities = AtmelAT91DIO2Capabilities;
    return PhysicalDIOInit(&AtmelAT91DIO2,BusInit(7),DIORawInit(1));
  }
  if (inst == 3) {
    for (i=0;i<=10;i++) {
      AtmelAT91DIO3Capabilities[i] = DIO_NORMAL;
    }
    AtmelAT91DIO3Capabilities[13] = DIO_NORMAL;
    AtmelAT91DIO3Capabilities[14] = DIO_NORMAL;
    AtmelAT91DIO3.Capabilities = AtmelAT91DIO3Capabilities;
    return PhysicalDIOInit(&AtmelAT91DIO3,BusInit(9),DIORawInit(2));
  }
  if (inst == 4) {
    for (i=0;i<=15;i++) {
      ts4200DIOCapabilities[i] = DIO_NORMAL;
    }
    ts4200DIOCapabilities[16] = DIO_NORMAL;
    ts4200DIOCapabilities[25] = DIO_NORMAL;
    ts4200DIOCapabilities[26] = DIO_NORMAL;
    ts4200DIOCapabilities[28] = DIO_NORMAL;
    
    ts4200DIOCapabilities[32] = DIO_OUTPUT_ONLY;
    ts4200DIOCapabilities[33] = DIO_OUTPUT_ONLY;
    ts4200DIO.Capabilities = ts4200DIOCapabilities;
    return PhysicalDIOInit(&ts4200DIO,BusInit(3),DIORawInit(3));
  }
  if (inst == 0) {
    return DIOInit0(&DIO0);
  }
  return dio;
}

SPI *ts4200_SPIInit(SPI *spi,int inst) {
  if (inst == 0) {
    if (!SPI0.LockNum) SPI0.LockNum = ThreadMutexAllocate(1);
    return AtmelAT91SPIInit(&SPI0,BusInit(13),PinInit(0),
			    DIOInit(2),25,DIOInit(2),26,DIOInit(2),27);
  }
  return spi;
}

TWI *ts4200_TWIInit(TWI *twi,int inst) {
  if (inst == 0) {
    TWI0.TW_CLK=24;
    TWI0.TW_DAT=23;
    TWI0.Speed=1000000;
    if (!TWI0.LockNum) TWI0.LockNum = ThreadMutexAllocate(1);
    return DIOTWIInit(&TWI0,DIOInit(0),TimeInit(0));
  }
  return twi;
}

AIO *ts4200_AIOInit(AIO *aio,int inst) {
  return aio;
}

ArchInfo ts4200_ArchInfo = {
  .Instances={1,14,1,1,4,5,1,0,1},
  .CANBusNum=0,
  .ArchInit=ts4200_ArchInit,
  .SystemInit=ts4200_SystemInit,
  .TimeInit=ts4200_TimeInit,
  .BusInit=ts4200_BusInit,
  .PinInit=ts4200_PinInit,
  .CANInit=ts4200_CANInit,
  .DIORawInit=ts4200_DIORawInit,
  .DIOInit=ts4200_DIOInit,
  .SPIInit=ts4200_SPIInit,
  .TWIInit=ts4200_TWIInit,
  .AIOInit=ts4200_AIOInit
  //.EDIOInit=ts4200_EDIOInit
};

#include "arch.c"

// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2012, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
