#include "Time.h"
#include "Bus.h"
#include "Pin.h"
#include "CAN.h"
#include "DIORaw.h"
#include "DIO.h"
#include "TWI.h"
#include "tsRelay8DIORaw.c"
#include "PhysicalDIO.h"
#include "arch.h"

static tsRelay8DIORaw dio[4];
static PhysicalDIO pdio[4];
static unsigned char Relay8DIOCapabilities[8];

System *tsrelay8_SystemInit(System *s,int inst) {
  return s;
}

Time *tsrelay8_TimeInit(Time *t,int inst) {
  return t;
}

Bus *tsrelay8_BusInit(Bus *bus,int inst) {
  return bus;
}

Pin *tsrelay8_PinInit(Pin *pin,int inst) {
  return pin;
}

CAN *tsrelay8_CANInit(CAN *can,int inst) {
  return can;
}
#include <stdio.h>
DIORaw *tsrelay8_DIORawInit(DIORaw *dioraw0,int inst) {
  Bus *muxbus = BusInit(2);
  int adrs = 0x140,i=0;
  DIORaw *dioraw;

  muxbus->API->Lock(muxbus,0,0);
  muxbus->API->BitClear16(muxbus,2,9); // make sure ISA reset de-asserted
  muxbus->API->Unlock(muxbus,0,0);
  if (inst >= 0 && inst <= 3) {
    while (inst >= 0 && adrs <= 0x170) {
      dioraw = tsRelay8DIORawInit(&dio[i],muxbus,adrs);
      if (dioraw) {
	inst--;
	i++;
      }
      adrs += 0x10;
    }
    return dioraw;
  }
  return dioraw0;
}

DIO *tsrelay8_DIOInit(DIO *dio,int inst) {
  DIORaw *dioraw;
  int i;
  if (inst >= 0 && inst <= 3) {
    dioraw = tsrelay8_DIORawInit(0,inst);
    if (dioraw) {
      for (i=0;i<8;i++) {
	Relay8DIOCapabilities[i] = DIO_OUTPUT_ONLY;
      }
      pdio[inst].Capabilities = Relay8DIOCapabilities;
      return PhysicalDIOInit(&pdio[inst],BusInit(2),dioraw);
    } else {
      return 0;
    }
  }
  return dio;
}

TWI *tsrelay8_TWIInit(TWI *twi,int inst) {
  return twi;
}

SPI *tsrelay8_SPIInit(SPI *spi,int inst) {
  return spi;
}

AIO *tsrelay8_AIOInit(AIO *aio,int inst) {
  return aio;
}

void tsrelay8_ArchInit() {
  if (!DIOInit(0)) {
    fprintf(stderr,"This binary was compiled with TS-RELAY8 support\n");
    fprintf(stderr,"Error: No TS-RELAY8 detected\n");
  }
}

ArchInfo tsrelay8_ArchInfo = {
  .Instances={0,0,0,0,1,1,0,0,0},
  .CANBusNum=0,
  .ArchInit=tsrelay8_ArchInit,
  .SystemInit=tsrelay8_SystemInit,
  .TimeInit=tsrelay8_TimeInit,
  .BusInit=tsrelay8_BusInit,
  .PinInit=tsrelay8_PinInit,
  .CANInit=tsrelay8_CANInit,
  .DIORawInit=tsrelay8_DIORawInit,
  .DIOInit=tsrelay8_DIOInit,
  .SPIInit=tsrelay8_SPIInit,
  .TWIInit=tsrelay8_TWIInit,
  .AIOInit=tsrelay8_AIOInit
  //.EDIOInit=tsrelay8_EDIOInit
};

